unit Conf;
interface
uses Windows,Messages,SysUtils,Classes,Graphics,Controls,Forms,Dialogs,
     StdCtrls,ExtCtrls,ComCtrls,Registry,Spin,SavInit;
type TD97Conf=class(TForm)
    OK:TButton;
    Cancel:TButton;
    OpenDialog:TOpenDialog;
    StatusBar1:TStatusBar;
    PageControl1:TPageControl;
    Delphi:TTabSheet;
    DelphiDx:TTabSheet;
    DDxLabel:TLabel;
    ListBox1:TListBox;
    DDxOpen:TButton;
    Help:TButton;
    DDxBlank:TCheckBox;
    DelphiLabel:TLabel;
    DFadeLabel1:TLabel;
    Image1:TImage;
    DFade:TSpinEdit;
    DHypno:TCheckBox;
    About:TTabSheet;
    D97Icon:TImage;
    AboutLabel:TLabel;
    AboutTimer:TTimer;
    AboutLabel1:TLabel;
    DReligion:TRadioGroup;
    DelayBar:TTrackBar;
    DelayEdit:TEdit;
    DelayLabel:TLabel;
    DDxStep:TCheckBox;
    AboutRegister:TLabel;
    procedure FormCreate(Sender:TObject);
    procedure HelpClick(Sender:TObject);
    procedure OKClick(Sender:TObject);
    procedure CancelClick(Sender:TObject);
    procedure DelayBarChange(Sender:TObject);
    procedure PageControl1Change(Sender:TObject);
    procedure DReligionClick(Sender:TObject);
    procedure ListBox1DblClick(Sender:TObject);
    procedure ValjFilClick(Sender:TObject);
    procedure AboutTimerTimer(Sender:TObject);
    procedure FormClose(Sender:TObject; var Action:TCloseAction);
    procedure FormDestroy(Sender:TObject);
  private
    function RandomBoolean:Boolean;
  public //it's very important that you leave this CreateParams intact, it's
         //essential to making this window modal to the screen properties dialog
    procedure CreateParams(var Params:TCreateParams);override;
  end;

var D97Conf:TD97Conf;
    MovingRightIcon,MovingDownIcon,MovingRightLabel,MovingDownLabel:Boolean;
implementation
Uses MMSystem;
{$R *.DFM}
{$R Darkside.res} //Include Darkside.wav, adds 50kb to exe

procedure TD97Conf.FormCreate(Sender:TObject);
var Registry:TRegistry;
    dum_int,i:Integer;
    dum_str:String;
begin //read config values from registry and setup values
  Registry:=TRegistry.Create;
  try
    Registry.RootKey:=HKEY_LOCAL_MACHINE;
    if Registry.OpenKey('Software\SIG Inc\Delphi 97 screensaver\1.0',False) then
    begin
      try
         if Registry.ReadBool('Delphi97') then
            PageControl1.ActivePage:=DelphiDx
         else
             PageControl1.ActivePage:=Delphi;
         If Registry.ReadInteger('Religion')=1 then
            DReligion.ItemIndex:=1
         else
             If Registry.ReadInteger('Religion')=2 then
                DReligion.ItemIndex:=2
         else
             DReligion.ItemIndex:=0;
         If Registry.ReadBool('Hypnotic') then
            DHypno.Checked:=True
         else
             DHypno.Checked:=False;
         DFade.Value:=Registry.ReadInteger('Fade');
         dum_int:=Registry.ReadInteger('Nr of chosen films');
         If dum_int>0 then
         begin
              For i:=1 to dum_int do
              begin
                   dum_str:=Registry.ReadString('Film'+IntToStr(i));
                   ListBox1.Items.Add(dum_str);
              end;
         end;
         If Registry.ReadBool('Blank') then
            DDxBlank.Checked:=True
         else
             DDxBlank.Checked:=False;
         If Registry.ReadBool('Step') then
            DDxStep.Checked:=True
         else
             DDxStep.Checked:=False;
         AboutRegister.Caption:='Registered to '+Registry.ReadString('Name')+
            ', '+Registry.ReadString('Company');
         DelayBar.Position:=Registry.ReadInteger('Delay');
         if DelayBar.Position=10000 then
            DelayEdit.Text:='    VB'
         else
             DelayEdit.Text:=InttoStr(DelayBar.Position)+' ms';
      except
            //Ignore exceptions
      end;
    end;
  finally
    Registry.CloseKey;
    Registry.Free;
  end;
  Randomize;
  MovingRightIcon:=RandomBoolean;
  MovingDownIcon:=RandomBoolean;
  MovingRightLabel:=RandomBoolean;
  MovingDownLabel:=RandomBoolean;
end;

procedure TD97Conf.HelpClick(Sender:TObject);
begin //Call help
     If PageControl1.ActivePage=Delphi then
        Application.HelpContext(3000)
     else
         if PageControl1.ActivePage=DelphiDx then
            Application.HelpContext(4000)
         else
             Application.HelpContext(1000); //About
end;

procedure TD97Conf.OKClick(Sender:TObject);
var Registry:TRegistry;
    i:Integer;
begin //Save ALL config values
  Registry:=TRegistry.Create;
  try
    Registry.RootKey:=HKEY_LOCAL_MACHINE;
    if Registry.OpenKey('Software\SIG Inc\Delphi 97 screensaver\1.0',True) then
    begin
         if PageControl1.ActivePage=DelphiDx then
            Registry.WriteBool('Delphi97',True)
         else
             Registry.WriteBool('Delphi97',False);
         If DReligion.ItemIndex=1 then
            Registry.WriteInteger('Religion',1)
         else
             If DReligion.ItemIndex=2 then
                Registry.WriteInteger('Religion',2)
         else
             Registry.WriteInteger('Religion',0);
         If DHypno.Checked=True then
            Registry.WriteBool('Hypnotic',True)
         else
             Registry.WriteBool('Hypnotic',False);
         Registry.WriteInteger('Fade',DFade.Value);
         If ListBox1.Items.Count>0 then
         begin
              Registry.WriteInteger('Nr of chosen films',ListBox1.Items.Count);
              For i:=1 to ListBox1.Items.Count do
                   Registry.WriteString('Film'+IntToStr(i),ListBox1.Items[i-1]);
         end
         else
             Registry.WriteInteger('Nr of chosen films',0);
         If DDxBlank.Checked=True then
            Registry.WriteBool('Blank',True)
         else
             Registry.WriteBool('Blank',False);
         If DDxStep.Checked=True then
            Registry.WriteBool('Step',True)
         else
             Registry.WriteBool('Step',False);
         Registry.WriteInteger('Delay',DelayBar.Position);
    end;
  finally
    Registry.CloseKey;
    Registry.Free;
    Close;
  end;
end;

procedure TD97Conf.CancelClick(Sender:TObject);
begin
     Close;
end;

procedure TD97Conf.DelayBarChange(Sender:TObject);
begin //Update text when Delaybar is changed
      If DelayBar.Position=10000 then
         DelayEdit.Text:='    VB'
      else
          DelayEdit.Text:=InttoStr(DelayBar.Position)+' ms';
     //AboutTimer.Interval:=DelayBar.Position;
end;

procedure TD97Conf.PageControl1Change(Sender:TObject);
begin //Enable/disable OK button and AboutTimer
     if PageControl1.ActivePage=About then
     begin
          OK.Enabled:=False;
          AboutTimer.Enabled:=True;
     end
     else
     begin
         OK.Enabled:=True;
         AboutTimer.Enabled:=False;
     end;
end;

procedure TD97Conf.DReligionClick(Sender:TObject);
begin //Insult Visual Basic fools
     If DReligion.ItemIndex=3 then
     begin
          If WaveOutGetNumDevs<>0 then //Only play if wave device present
             PlaySound('DARKSIDE',hInstance,SND_Resource or SND_Async);
          DReligion.ItemIndex:=0;
     end;
end;

procedure TD97Conf.ListBox1DblClick(Sender:TObject);
begin //Delete selected item from AviListBox
     ListBox1.Items.Delete(ListBox1.ItemIndex);
end;

procedure TD97Conf.ValjFilClick(Sender:TObject);
begin //Add chosen OpenDialog box item to AviListBox
     If OpenDialog.Execute then
        ListBox1.Items.Add(OpenDialog.FileName);
end;

procedure TD97Conf.AboutTimerTimer(Sender:TObject);
begin //Move icon and label around About box
     If MovingRightIcon then
          if D97Icon.Left<(About.Width-(D97Icon.Width-1)) then
             D97Icon.Left:=D97Icon.Left+2
          else
              MovingRightIcon:=False
     else
         if D97Icon.Left>1 then
            D97Icon.Left:=D97Icon.Left-2
         else
             MovingRightIcon:=True;
     If MovingDownIcon then
          if D97Icon.Top<(About.Height-(D97Icon.Height-1)) then
             D97Icon.Top:=D97Icon.Top+2
          else
              MovingDownIcon:=False
     else
         if D97Icon.Top>1 then
            D97Icon.Top:=D97Icon.Top-2
         else
             MovingDownIcon:=True;
     If MovingRightLabel then
          if AboutLabel.Left<(About.Width-AboutLabel.Width) then
             AboutLabel.Left:=AboutLabel.Left+1
          else
              MovingRightLabel:=False
     else
         if AboutLabel.Left>0 then
            AboutLabel.Left:=AboutLabel.Left-1
         else
             MovingRightLabel:=True;
     If MovingDownLabel then
          if AboutLabel.Top<(About.Height-AboutLabel.Height) then
             AboutLabel.Top:=AboutLabel.Top+1
          else
              MovingDownLabel:=False
     else
         if AboutLabel.Top>0 then
            AboutLabel.Top:=AboutLabel.Top-1
         else
             MovingDownLabel:=True;
end;

procedure TD97Conf.FormClose(Sender:TObject; var Action:TCloseAction);
begin
  if ConfigParent<>0 then
  begin //as I made myself modal, I should undo it now
    EnableWindow(ConfigParent,true);
    SetForegroundWindow(ConfigParent);
  end;
end;

procedure TD97Conf.FormDestroy(Sender:TObject);
begin //Kill sound, if playing
     SndPlaySound(NIL,SND_Async or SND_NoDefault);
end;

function TD97Conf.RandomBoolean:Boolean;
begin //Generate a random boolean value
     If (Trunc(Random(2)))=0 then
        RandomBoolean:=True
     else
         RandomBoolean:=False;
end;

procedure TD97Conf.CreateParams(var Params:TCreateParams);
begin
  inherited Createparams(Params);
  if ConfigParent<>0 then begin
    //this is necessary to make myself a child window of the screen
    //properties dialog, the effect is, when I click on my config dialog,
    //that the screen properties dialog shows up behind my dialog
    Params.WndParent:=ConfigParent;
    EnableWindow(ConfigParent,false); //My dialog should be modal, so disable parent
  end;
end;

end.
